ad_page_contract {
    page to add a new file to the system

    @author Kevin Scaldeferri (kevin@arsdigita.com)
    @creation-date 6 Nov 2000
    @cvs-id $Id$
} {
    project_id:integer
    { path ""}
    upload_file:trim,optional
    upload_file.tmpfile:tmpfile,optional
    { title "" }
    { description "description" }
}

set user_id [ad_conn user_id]
set n_bytes [file size ${upload_file.tmpfile}]
set package_id [ad_conn package_id]
set package_id [db_string package "select min(package_id) from apm_packages where package_key = 'file-storage'" -default $package_id]

ns_log Notice "upload: project_id=$project_id, path=$path, upload_file=$upload_file, tmp_file=${upload_file.tmpfile}"


set ttt {
set max_bytes [parameter::get -parameter "MaximumFileSize"]
if {$n_bytes > $max_bytes } {
    ad_return_complaint 1 "Your file is larger than the maximum file size allowed on this system ([util_commify_number $max_bytes] bytes)"
    ad_script_abort
}
}

set folder_id [im_rest_fs_folder_for_path -object_id $project_id -path $path]
set mime_type [cr_filename_to_mime_type -create -- $upload_file]
set file_id [db_nextval "acs_object_id_seq"]
ns_log Notice "upload: folder_id=$folder_id, file_id=$file_id, mime_type=$mime_type"

if {1} {
    fs::add_file \
        -name $upload_file \
        -item_id $file_id \
        -parent_id $folder_id \
        -tmp_filename ${upload_file.tmpfile} \
        -creation_user $user_id \
        -creation_ip [ad_conn peeraddr] \
        -title $upload_file \
        -description $description \
        -package_id $package_id \
        -mime_type $mime_type
}

file delete ${upload_file.tmpfile}


ns_log Notice "upload: Finished"

doc_return 200 "text/plain" "project_id=$project_id, path=$path, file_id=$file_id, folder_id=$folder_id, upload_file=$upload_file, tmp_file=${upload_file.tmpfile}, cont="
ad_script_abort

